#!/usr/bin/perl


use Pg;
require('../common/config');
require('../common/selection');


# read query string
$oid = $ENV{'QUERY_STRING'};

print "Content-type: text/html

<title>Edit A/P Transaction</title>

<body bgcolor=ffffff>
";


# connect to database
$conn = PQsetdb($pghost, $pgport, $pgoptions, $pgtty, $dbname);
(PQstatus($conn) == PGRES_CONNECTION_OK) || die "Could not connect to database $dbname";


# retrieve record
$query = "select * from ap where oid = $oid;";
$pt = PQexec($conn, $query);
# check if it is still there
$n = PQntuples($pt);

if ($n) {
  $invnumber = PQgetvalue($pt, 0, 0);
  $invdate = PQgetvalue($pt, 0, 1);
  $vendor = PQgetvalue($pt, 0, 2);
  $amount = PQgetvalue($pt, 0, 3);
  $tax1 = PQgetvalue($pt, 0, 4);
  $tax2 = PQgetvalue($pt, 0, 5);
  $currency = PQgetvalue($pt, 0, 6);
  $amountpaid = PQgetvalue($pt, 0, 7);
  $datepaid = PQgetvalue($pt, 0, 8);
  $duedate = PQgetvalue($pt, 0, 9);
  $ordnumber = PQgetvalue($pt, 0, 10);
  $chqnumber = PQgetvalue($pt, 0, 11);
  
  $vendors = &buildselection($vendor, "vendor", "vendor");
  $curr = &currselection($currency, "currency");

  $outstanding = sprintf("%.2f", $amount + $tax1 - $amountpaid);


  print "
  <h2>Editing $tablename Transaction</h2>

  <form method=post action=update.pl>


  <table border=1>
  <tr valign=top>
  <td>
  <table>

  <tr>
  <th align=right>Vendor:</th><td colspan=3>$vendors</td>
  </tr>

  <tr>
  <th align=right>Invoice Number:</th><td><input name=invnumber value=\"$invnumber\" size=12></td>
  <th align=right>Order Number:</th><td><input name=ordnumber value=\"$ordnumber\" size=8></td>
  </tr>

  <tr>
  <th align=right>Invoice Date:</th><td><input name=invdate value=\"$invdate\" size=10></td>
  <th align=right>Due Date:</th><td><input name=duedate value=\"$duedate\" size=10></td>
  </tr>

  <tr>
  <th align=right>Amount:</th><td><input name=amount value=\"$amount\" size=10> $curr</td>
  <th align=right>GST:</th><td><input name=tax1 value=\"$tax1\" size=8></td>
  </tr>

  <tr>
<th align=right>Date Paid:</th><td><input name=datepaid value=\"$datepaid\" size=10> <b>Chq #: </b><td><input name=chqnumber value=\"$chqnumber\" size=4></td>
  <th align=right>Amount Paid:</th><td><input name=amountpaid value=\"$amountpaid\" size=10></td>
  </tr>

  <tr>
  <th align=center colspan=4>Outstanding: $outstanding</th>
  </tr>


  </table>
  </td>

  </tr>
  </table>
  
  <input type=hidden name=oid value=$oid>
  <p><input type=submit value=Update>
  </form>
  ";
} else {
  # record is gone
  print "<h2><font color=red>Record does not exist anymore!</font></h2>";
}

PQclear($pt);
PQfinish($conn);

print "
</body>
</html>
";


