#!/usr/bin/perl


use Pg;
require('../common/config');
require('../common/wwwutil');

# open stdin
read(STDIN, $_, $ENV{'CONTENT_LENGTH'});

# put items in array
@_ = split(/&/);

foreach (@_) {
  ($key, $value) = split(/=/);
  $var{$key} = &unescape(uc $value);
}


print "Content-type: text/html\n\n";
print "<body bgcolor=ffffff>\n";



print "<h2>A/P Listing</h2>\n";


$query = "select a.invnumber,a.invdate,s.name,a.amount+a.tax1+a.tax2,";
$query .= "a.currency,a.amountpaid,a.duedate,s.oid,a.oid,a.ordnumber ";
$query .= "from ap a, vendor s where a.vendor = s.id ";

$iquery = "and a.invnumber like \'\%$var{'invnumber'}\%\' " if ($var{'invnumber'});
$iquery .= "and a.ordnumber like \'\%$var{'ordnumber'}\%\' " if ($var{'ordnumber'});
$iquery .= "and a.chqnumber = $var{'chqnumber'} " if ($var{'chqnumber'});

if ($iquery) {
  $query .= $iquery;
} else {
  $noquery = 1;
}


if ($noquery) {
  ;
} else {
  
# connect to database
$conn = PQsetdb($pghost, $pgport, $pgoptions, $pgtty, $dbname);
(PQstatus($conn) == PGRES_CONNECTION_OK) || die "Could not connect to database $dbname";

$query .= "order by a.invdate;";

$ct = PQexec($conn, $query);
$n = PQntuples($ct);

if ($n) {

#09-09-1998 12345678901234567890 1234567890 12345678 12345.99 CDN 12345.99

  print "<pre>

   Date           Vendor           Invoice No  Order No   Amount     Paid CUR
-----------------------------------------------------------------------------
";

  for $i (0 .. $n-1) {
    
    $invnumber = PQgetvalue($ct, $i, 0);
    $invdate = PQgetvalue($ct, $i, 1);
    $vendor = PQgetvalue($ct, $i, 2);
    $amount = sprintf("%.2f", PQgetvalue($ct, $i, 3));
    $currency = PQgetvalue($ct, $i, 4);
    $amountpaid = sprintf("%.2f", PQgetvalue($ct, $i, 5));
    $duedate = PQgetvalue($ct, $i, 6);
    
    $soid = PQgetvalue($ct, $i, 7);
    $oid = PQgetvalue($ct, $i, 8);

    $ordnumber = PQgetvalue($ct, $i, 9);

    # keep a running total
    $total{$currency} += $amount;
    $totalpaid{$currency} += $amountpaid;
  
    printf("%s", $invdate);
    printf(" <a href=/vendor/edit.pl?%s>%s</a>", $soid, substr($vendor,0,23));
    $padding = " " x (23-length($vendor));
    printf("%s", $padding);
    
    printf(" <a href=edit.pl?%s>%s</a>", $oid, substr($invnumber,0,11));
    
    $padding = " " x (11-length($invnumber));
    printf("%s", $padding);
    
    printf(" %-8s %8.2f %8.2f %3s\n", $ordnumber, $amount, $amountpaid, $currency);
    
  }
  

  print "</pre>";
  
} else {
  print "<h2><font color=red>Transaction not on file!</font></h2>";
}

PQclear($ct);

PQfinish($conn);
}

print "

<p>
<br><a href=add.pl>Add Transaction</a>
<br>Click on Vendor to edit VENDOR
<br>Click on Invoice Number to edit TRANSACTION

</body>
</html>
";

