#!/usr/bin/perl


use Pg;
require('dbstruct');
require('../common/config');
require('../common/wwwutil');


# open stdin
read(STDIN, $_, $ENV{'CONTENT_LENGTH'});


# connect to database
$conn = PQsetdb($pghost, $pgport, $pgoptions, $pgtty, $dbname);
(PQstatus($conn) == PGRES_CONNECTION_OK) || die "Could not connect to database $dbname";


print "Content-type: text/html\n";


# put items in array
@items = split(/&/);

foreach $item (@items) {
  ($key, $value) = split (/=/, $item);
  $var{$key} = $value;
}


$query = "update $table set ";

# strip ^M from notes
#$var{'notes'} =~ s/%0[dD]//g;

for $i (0 .. $#fldlabels) {
  #check if we need the field filled in
  if ($fldlabels[$i][3]) {
    if (!($var{$fldlabels[$i][0]})) {
      print "
      <body bgcolor=ffffff>

      <h2>Status</h2>
      
      <h2><font color=red>$fldlabels[$i][3] must be filled in!</font></h2>";
      exit 1;
    }
  }
  
  if ($fldlabels[$i][1] eq "C") {
    $str = uc &unescape($var{$fldlabels[$i][0]});
    if ($fldlabels[$i][2]) {
      $str =~ s/ //g;
    }
    $query .= "$fldlabels[$i][0] = '$str',";
  }

  if ($fldlabels[$i][1] eq "L") {
    $str = uc $var{$fldlabels[$i][0]};
    if (($str eq "T") || ($str eq "Y")) {
      $str = "t";
    } else {
      $str = "f";
    }
    $query .= "$fldlabels[$i][0] = '$str',";
  }

  if ($fldlabels[$i][1] eq "D") {
    $str = &unescape($var{$fldlabels[$i][0]});
    if ($var{$fldlabels[$i][0]}) {
      $query .= "$fldlabels[$i][0] = '$str',";
    } else {
      $query .= "$fldlabels[$i][0] = NULL,";
    }
  }

  if ($fldlabels[$i][1] eq "N") {
    if ($var{$fldlabels[$i][0]}) {
      $query .= "$fldlabels[$i][0] = $var{$fldlabels[$i][0]},";
    } else {
      $query .= "$fldlabels[$i][0] = 0,";
    }
  }

  if ($fldlabels[$i][1] eq "S") {
    #split into id, name pair
    @a = split(/--/, $var{$fldlabels[$i][0]});
    $query .= "$fldlabels[$i][0] = $a[1],";
  }
}

#remove last comma
chop $query;

# add oid
$query .= " where oid = $var{'oid'};";
$ct = PQexec($conn, $query);

$result = PQresultStatus($ct);

# clear memory
PQclear($ct);

if ($result) {
  print "
  <body bgcolor=ffffff>

  <h2>Status</h2>
      
  <h2><font color=blue>Updated $tablename record</font></h2>\n";
}


PQfinish($conn);


print "
</body>
</html>
";


