#!/usr/bin/perl


use Pg;
require('../common/config');
require('dbstruct');

# pass string to sort by
$sortorder = $ENV{'QUERY_STRING'};


print "Content-type: text/html

<title>Bank Reconciliation</title>

<body bgcolor=ffffff>
";


# connect to database
$conn = PQsetdb($pghost, $pgport, $pgoptions, $pgtty, $dbname);
(PQstatus($conn) == PGRES_CONNECTION_OK) || die "Could not connect to database $dbname";


print "<h2>$tablename / Reconciliation</h2>\n";


$query = "select *,oid from $table where cleared = 'f' order by $sortorder;";

$ct = PQexec($conn, $query);
$n = PQntuples($ct);

if ($n) {

  print "
  <form method=post action=clear.pl>
  
  <pre>

   Date    Description               Deposits  Cheques  Chq#  Clear
-------------------------------------------------------------------
";
#09-09-1998 1234567890123456789012345 12345.78 12345.78 1234   1234
#  <a href=reconcile.pl?transdate>Date</a>
#  <a href=reconcile.pl?description,transdate>Description</a>
#  <a href=reconcile.pl?chqnumber>Chq #</a>

  for $i (0 .. $n-1) {

    $transdate = PQgetvalue($ct, $i, 0);
    $description = PQgetvalue($ct, $i, 1);
    $amount = PQgetvalue($ct, $i, 2);
    $chqnumber = PQgetvalue($ct, $i, 3);
    $cleared = PQgetvalue($ct, $i, 4);

    $oid = PQgetvalue($ct, $i, 5);

    # keep a running total
    if ($amount > 0) {
      $deposits += $amount;
    } else {
      $withdrawals += $amount;
    }
 
    printf("%s <a href=edit.pl?%s>%s</a>", $transdate, $oid, substr($description,0,25));

    $padding = 25 - length($description);
    $padding = ($padding < 0) ? 0 : $padding;
    printf("%s", " " x $padding);

    if ($amount < 0) {
      printf(" %s", " " x 8);
      printf(" %8.2f", -$amount);
    } else {
      printf(" %8.2f %s", $amount, " " x 8);
    }
    
    printf("  %4d   <input type=checkbox name=oid value=%s>\n", $chqnumber, $oid);
  }

  printf("\n   Total Deposits:  %10.2f\n", $deposits);
  printf("Total Withdrawals:  %10.2f\n", -$withdrawals);
  printf("       Difference:  %10.2f\n", $deposits + $withdrawals);
  
  print "</pre>
  <p>
  <input type=submit value=\"Clear Transactions\">
  </form>";
  
} else {
  print "<h2><font color=red>Nothing to reconcile!</font></h2>";
}

PQclear($ct);

PQfinish($conn);

print "

<p>
Click on the table header to sort table.
<br>Click on Description to edit TRANSACTION
<br>Check off box in the \"Clear\" column.
When you're done click on \"Clear marked Transactions\" to process.

</body>
</html>
";

