#!/usr/bin/perl


use Pg;
require('../common/config');
require('../common/selection');


# read query string
$_ = $ENV{'QUERY_STRING'};
split(/&/);
$number = $_[0];
$oid = $_[1];

print "Content-type: text/html\n\n";
print "<body bgcolor=ffffff>\n";


# connect to database
$conn = PQsetdb($pghost, $pgport, $pgoptions, $pgtty, $dbname);
(PQstatus($conn) == PGRES_CONNECTION_OK) || die "Could not connect to database $dbname";


# retrieve record, use index to locate part
# oid alone takes too long
$query = "select * from parts where number = \'$number\' and oid = $oid;";
$pt = PQexec($conn, $query);
# check if it is still there
$n = PQntuples($pt);

if ($n) {
  $number = PQgetvalue($pt, 0, 0);
  $description = PQgetvalue($pt, 0, 1);
  $list_price = PQgetvalue($pt, 0, 2);
  $list_currid = PQgetvalue($pt, 0, 3);
  $makeid = PQgetvalue($pt, 0, 4);
  $weight_kg = PQgetvalue($pt, 0, 5);
  $sell_price = PQgetvalue($pt, 0, 6);
  $sell_currid = PQgetvalue($pt, 0, 7);
  $notes = PQgetvalue($pt, 0, 8);
  $model = PQgetvalue($pt, 0, 9);
  $serialnumber = PQgetvalue($pt, 0, 10);
  $priceupdate = PQgetvalue($pt, 0, 11);

  $makes = &buildselection($makeid,"make","make");
  $list_curr = &currselection($list_currid, "list_curr");
  $sell_curr = &currselection($sell_currid, "sell_curr");

  # get alternates
  $query = "select alt_number from alternate where oem_number = \'$number\' ";
  $query .= "and oem_make = \'makeid\';";
  $result = PQexec($conn, $query);
  $k = PQntuples($result);
  
  if ($k) {
    $alternates = PQgetvalue($result, 0, 0);
    for $i (1 .. $k-1) {
      $alternates .= "<br><a href=search.pl?";
      $alternates .= PQgetvalue($result, $i, 0);
      $alternates .= "</a>";
    }
  }

  PQclear($result);
  
  
  print "
  <h2>Editing Part Number: $number</h2>

  <form method=post action=update.pl>
  
  <table border=1>
  <tr valign=top>
  <td>
  <table>

  <tr><th align=right>Description:</th><td><input name=description value=\"$description\" size=35 maxlength=35></td></tr>
  <tr><th align=right>Make:</th><td>$makes</td></tr>
  <tr><th align=right>Model:</th><td><input name=model value=\"$model\" size=35></td></tr>
  <tr><th align=right>Serial #:</th><td><input name=serialnumber value=\"$serialnumber\" size=35></td></tr>
  <tr><th align=right>Alternates:</th><td>$alternates</a></td></tr>
  </table>
  </td>

  <td>
  <table>
  
  <tr><th align=right>List:</th><td><input name=list_price value=\"$list_price\" size=8></td><td>$list_curr</td></tr>
  <tr><th align=right>Sell:</th><td><input name=sell_price value=\"$sell_price\" size=8></td><td>$sell_curr</td></tr>
  <tr><th align=right>Price Updated:</th><td colspan=2><input name=priceupdate value=\"$priceupdate\" size=10></tr>
  <tr><th align=right>Weight (kg):</th><td colspan=2><input name=weight_kg value=\"$weight_kg\" size=8></td></tr>
  
  </table>

  </td>
  </tr>

  <tr><td colspan=2><b>Notes:</b> <textarea name=notes cols=62 rows=4>$notes</textarea></td></tr>
  
  </table>

  <input type=hidden name=number value=$number>
  <input type=hidden name=oid value=$oid>
  <p><input type=submit value=Update>
  </form>
  ";
} else {
  # record is gone
  print "<h2><font color=red>Record does not exist anymore!</font></h2>";
}

PQclear($pt);
PQfinish($conn);

print "
</body>
</html>
";


