#!/usr/bin/perl


use Pg;
require('../common/config');


# read STDIN
read(STDIN, $_, $ENV{'CONTENT_LENGTH'});


# if we pass it via URI
if ($number = $ENV{'QUERY_STRING'}) {
  $_ = $number;
}


# strip number= at beginning
s/^number=//;

# translate to upper case
tr/a-z/A-Z/;
tr/+/ /;

print "Content-type: text/html

<title>Parts Search Results</title>

<body bgcolor=ffffff>
";

# put items in array
@pn = split(/ +/);


# connect to database
$conn = PQsetdb($pghost, $pgport, $pgoptions, $pgtty, $dbname);
(PQstatus($conn) == PGRES_CONNECTION_OK) || die "Could not connect to database $dbname";

print "
<h2>Parts Search Result</h2>

";

# check each item in database
foreach $item (@pn) {

  $item =~ s/%(..)/pack("c",hex($1))/ge;

  $query = "select *,oid from parts where number = \'$item\';";
  
  $parts = PQexec($conn, $query);
  $n = PQntuples($parts);

  format STDOUT =
<pre>
---------------------------------------------------------------------

<b>Part Number:</b>  @<<<<<<<<<<<<<<<<  @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
              $number,           $description
<b>Make:</b>  @<<<<<<<<<<<<<<<<<<<<<<<  <b>Model:</b> @<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       $make,                           $model
<b>Serial Number:</b>  @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                $serialnumber
<b>List:</b>  @#####.## @<<< => @#####.## CDN      <b>Weight (kg):</b>  @####.###
$list_price, $lc, $list_price * $list_exch, $weight_kg
<b>Sell:</b>  @#####.## @<<< => @#####.## CDN   <b>Price Updated:</b>  @<<<<<<<<<<
$sell_price, $sc, $sell_price * $sell_exch, $priceupdate
<b>Notes:</b> ^<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       $notes
       ^<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<~~
       $notes
</pre>
.

  if ($n) {
    for $i (0 .. $n-1) {
      $number = PQgetvalue($parts, $i, 0);
      $description = PQgetvalue($parts, $i, 1);
      $list_price = PQgetvalue($parts, $i, 2);
      $lc = PQgetvalue($parts, $i, 3);
      $mk = PQgetvalue($parts, $i, 4);
      $weight_kg = PQgetvalue($parts, $i, 5);
      $sell_price = PQgetvalue($parts, $i, 6);
      $sc = PQgetvalue($parts, $i, 7);
      $notes = PQgetvalue($parts, $i, 8);
      $model = PQgetvalue($parts, $i, 9);
      $serialnumber = PQgetvalue($parts, $i, 10);
      $priceupdate = PQgetvalue($parts, $i, 11);
      $oid = PQgetvalue($parts, $i, 12);

      # get make name
      $query = "select name from make where id = $mk;";
      $makes = PQexec($conn, $query);
      $make = "";
      if (PQntuples($makes)) {
	  $make = PQgetvalue($makes, 0, 0);
      }
      PQclear($makes);
      
      # get list currency exchange rate
      $query = "select sell from currency where id = \'$lc\';";
      $curr = PQexec($conn, $query);
      if (PQntuples($curr)) {
	  $list_exch = PQgetvalue($curr, 0, 0);
      }
      PQclear($curr);
      
      # get sell currency exchange rate
      $query = "select sell from currency where id = \'$sc\';";
      $curr = PQexec($conn, $query);
      if (PQntuples($curr)) {
	  $sell_exch = PQgetvalue($curr, 0, 0);
      }
      PQclear($curr);
      

      $alternates = "";
      # get alternates
      $query = "select alt_number from alternate where oem_number = \'$number\' ";
      $query .= "and oem_make = $mk;";
      
      $alt = PQexec($conn, $query);
      if (PQntuples($alt)) {
	$k = PQntuples($alt);
	for $j (0..$k-1) {
	  $altnumber = PQgetvalue($alt, $j, 0);
	  $alternates .= "<a href=/alternate/search.pl?$altnumber>$altnumber</a>\n";
	}
      }
      PQclear($alt);


      write;
      
      print "<b>Alternates:</b> $alternates<p>" if ($alternates);

      print "
[ <a href=/supply/search.pl?$item>Check Supply</a> ] 
[ <a href=edit.pl?$item\&$oid>Edit</a> ] 
[ <a href=delete.pl?$item\&$oid>Delete</a> ]
";

    }
  } else {
    print "<p><hr>
    <font color=red size=+3><a href=add.pl?$item>$item</a> not on file!</font>
    <-- Click on number to add!
    ";
  }
  PQclear($parts);
}

PQfinish($conn);

print "

</body>
</html>
";


