#!/usr/bin/perl


use Pg;
require('../common/config');


# open stdin
read(STDIN, $_, $ENV{'CONTENT_LENGTH'});

# put items in array
@_ = split(/&/);

foreach (@_) {
  ($key, $value) = split(/=/);
  $var{$key} = $value;
}

# connect to database
$conn = PQsetdb($pghost, $pgport, $pgoptions, $pgtty, $dbname);
(PQstatus($conn) == PGRES_CONNECTION_OK) || die "Could not connect to database $dbname";


print "Content-type: text/html

<title>GST Report</title>

<body bgcolor=ffffff>

";



$query = "select a.invdate,a.invnumber,c.name,a.amount,a.tax1 from ar a,customer c where (a.tax1*100)::int <>0 and a.invdate >= \'$var{datefrom}\' and a.invdate <= \'$var{dateto}\' and a.customer = c.id order by a.invdate";

$ct = PQexec($conn, $query);
$n = PQntuples($ct);

if ($n) {
  print "<h2>Tax collected</h2>

  <pre>

   Date     Invoice    Customer                      Amount      GST
---------------------------------------------------------------------
";


format STDOUT =
@<<<<<<<<<< @<<<<<<<<< @<<<<<<<<<<<<<<<<<<<<<<<<< @#####.## @#####.##
$invdate, $invnumber, $name, $amount, $tax1
.

  for $i (0 .. $n-1) {
    $invdate = PQgetvalue($ct, $i, 0);
    $invnumber = PQgetvalue($ct, $i, 1);
    $name = PQgetvalue($ct, $i, 2);
    $amount = sprintf("%.2f", PQgetvalue($ct, $i, 3));
    $tax1 = sprintf("%.2f", PQgetvalue($ct, $i, 4));
   
    $subtotal += $amount;
    $subgst += $tax1;

    write();
  }
}


# clear memory
PQclear($ct);

print "                                                  ---------   -------\n";
printf("                                                  %9.2f  %8.2f\n", $subtotal, $subgst);

print "</pre>";


$subtotal = 0;
$subgst = 0;

$query = "select a.invdate,a.invnumber,c.name,a.amount,a.tax1 from ap a,vendor c where a.invdate >= \'$var{datefrom}\' and a.invdate <= \'$var{dateto}\' and a.vendor = c.id order by a.invdate";

$ct = PQexec($conn, $query);
$n = PQntuples($ct);

if ($n) {
  print "<h2>Tax paid</h2>

  <pre>

   Date     Invoice    Vendor                        Amount      GST
---------------------------------------------------------------------
";


format STDOUT =
@<<<<<<<<<< @<<<<<<<<< @<<<<<<<<<<<<<<<<<<<<<<<<< @#####.## @#####.##
$invdate, $invnumber, $name, $amount, $tax1
.

  for $i (0 .. $n-1) {
    $invdate = PQgetvalue($ct, $i, 0);
    $invnumber = PQgetvalue($ct, $i, 1);
    $name = PQgetvalue($ct, $i, 2);
    $amount = sprintf("%.2f", PQgetvalue($ct, $i, 3));
    $tax1 = sprintf("%.2f", PQgetvalue($ct, $i, 4));
   
    $subtotal += $amount;
    $subgst += $tax1;

    write();
  }
}


# clear memory
PQclear($ct);

print "                                                  ---------   -------\n";
printf("                                                  %9.2f  %8.2f\n", $subtotal, $subgst);

print "</pre>";



PQfinish($conn);


print "
</body>
</html>
";


