#!/usr/bin/perl


use Pg;
require('../common/config');
require('../common/wwwutil');


# open stdin
read(STDIN, $_, $ENV{'CONTENT_LENGTH'});

# connect to database
$conn = PQsetdb($pghost, $pgport, $pgoptions, $pgtty, $dbname);
(PQstatus($conn) == PGRES_CONNECTION_OK) || die "Could not connect to database $dbname";



# put items in array
split(/&/);

foreach (@_) {
  ($key, $value) = split(/=/);
  $var{$key} = $value;
}


$query = "insert into parts values (";


# get make id
# var{'make'} is made up of 'name--id' in buildselection
# make sure there are no spaces between name, --, and id
# otherwise we need to unescape the string
@_ = split(/--/,$var{'make'});
$var{'make'} = $_[1];


# remove all spaces in the part number
$var{'number'} = uc &unescape($var{'number'});
$var{'number'} =~ s/ //g;


# unescape description
$var{'description'} = uc &unescape($var{'description'});


# strip ^M from notes, leave for now!
# need to work out how to store multiline field so other apps
# can look at it too
# ^M\ is easy to remove
#
#$var{'notes'} =~ s/%0[dD]//g;
$var{'notes'} = uc &unescape($var{'notes'});

# unescape model and serialnumber
$var{'model'} = uc &unescape($var{'model'});
$var{'serialnumber'} = uc &unescape($var{'serialnumber'});

# add number and description
$query .= "\'$var{'number'}\',\'$var{'description'}\',";

# add list price, need a number or postgres bombs out
$query .= $var{'list_price'} ? $var{'list_price'} : 0;

# currency and make id
$query .= ",\'$var{'list_curr'}\',$var{'make'},";

# weight, see above
$query .= $var{'weight_kg'} ? $var{'weight_kg'} : 0;
$query .= ",";

# selling price
$query .= $var{'sell_price'} ? $var{'sell_price'} : 0;

# sell currency and notes
$query .= ",\'$var{'sell_curr'}\',\'$var{'notes'}\',\'$var{'model'}\'";
$query .= ",\'$var{'serialnumber'}\'";

if ($var{'priceupdate'}) {
  $query .= ",\'$var{'priceupdate'}\'";
}

$query .= ");";


$pt = PQexec($conn, $query);

$result = PQresultStatus($pt);

# clear memory
PQclear($pt);


print "Content-type: text/html

<body bgcolor=ffffff>

<h2>Status</h2>
";


if ($result) {
  print "

<h2><font color=blue>Added Part Number $var{'number'}</font></h2>";
} else {
  print "

<h2><font color=red>ERROR:</font> Could not add Part Number $var{'number'}</h2>";

}


PQfinish($conn);


print "
</body>
</html>
";

