#!/usr/bin/perl


use Pg;
require('../common/config');


# read STDIN
read(STDIN, $_, $ENV{'CONTENT_LENGTH'});


# if we pass it via URI
if ($number = $ENV{'QUERY_STRING'}) {
  $_ = $number;
}


# strip number= at beginning
s/^number=//;

# translate to upper case
tr/a-z/A-Z/;
tr/+/ /;

print "Content-type: text/html

<title>Supply Search Results</title>

<body bgcolor=ffffff>
";

# put items in array
@pn = split(/ +/);


# connect to database
$conn = PQsetdb($pghost, $pgport, $pgoptions, $pgtty, $dbname);
(PQstatus($conn) == PGRES_CONNECTION_OK) || die "Could not connect to database $dbname";

print "
<h2>Supply Search Result</h2>

";

  format STDOUT =
<pre>
---------------------------------------------------------------------

<b>Part Number:</b>  @<<<<<<<<<<<<<<<<  @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
$number, $description
<b>Make:</b>  ^<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<~~
$make
<b>Model:</b>  ^<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<~~
$model
<b>Serial Number:</b>  ^<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<~~
$serialnumber
<b>List:</b>  @#####.## @<<< => @#####.## CDN      <b>Weight (kg):</b>  @#####.###
$list_price, $list_curr, $list_price * $var{$list_curr}, $weight_kg
<b>Sell:</b>  @#####.## @<<< => @#####.## CDN    <b>Price Updated:</b>  @<<<<<<<<<<
$sell_price, $sell_curr, $sell_price * $var{$sell_curr}, $ppriceupdate
<b>Notes:</b> ^<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<~~
$pnotes
       ^<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<~~
$pnotes

<b>Cost:</b>  @#####.## @<<< => @#####.## CDN    <b>Price Updated:</b>  @<<<<<<<<<<
$cost_price, $cost_curr, $cost_price * $var{$cost_curr}, $spriceupdate
<b>Supplier:</b>  @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<  <b>Tel:</b>  @<<<<<<<<<<<<<<<
$supplier, $phone
<b>Contact:</b>   @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<  <b>Fax:</b>  @<<<<<<<<<<<<<<<
$contact, $fax
<b>email:</b>  @*
$email
<b>Notes:</b> ^<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<~~
       $snotes
       ^<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<~~
       $snotes

<b>Alternates:</b>  @*
$alternates
</pre>
.

# load currencies into array
$query = "select id,sell from currency;";
$ct = PQexec($conn,$query);
$n = PQntuples($ct);
for $i (0 .. $n-1) {
  $id = PQgetvalue($ct,$i,0);
  $var{$id} = PQgetvalue($ct,$i,1);
}
PQclear($ct);


# check each item in database
foreach $item (@pn) {

  $item =~ s/%(..)/pack("c",hex($1))/ge;

  $query = "select sp.number,sp.cost_price,sp.cost_curr,sp.notes,";
  $query .= "sp.priceupdate,";
  $query .= "p.description,p.make,p.model,p.serialnumber,";
  $query .= "p.list_price,p.list_curr,p.sell_price,p.sell_curr,";
  $query .= "p.weight_kg,p.notes,p.priceupdate,";
  $query .= "s.name,s.contact,s.phone,s.fax,s.email,";
  $query .= "sp.oid,p.oid,s.oid ";
  $query .= "from supply sp,parts p,supplier s ";
  $query .= "where sp.number = \'$item\' ";
  $query .= "and sp.number = p.number ";
  $query .= "and sp.supplier_id = s.id; ";
 

  $parts = PQexec($conn, $query);
  $n = PQntuples($parts);

  if ($n) {
    for $i (0 .. $n-1) {
      $k = 0;
      $number = PQgetvalue($parts, $i, $k++);
      $cost_price = PQgetvalue($parts, $i, $k++);
      $cost_curr = PQgetvalue($parts, $i, $k++);
      $snotes = PQgetvalue($parts, $i, $k++);
      $spriceupdate = PQgetvalue($parts, $i, $k++);
      
      $description = PQgetvalue($parts, $i, $k++);
      $mk = PQgetvalue($parts, $i, $k++);
      $model = PQgetvalue($parts, $i, $k++);
      $serialnumber = PQgetvalue($parts, $i, $k++);
      $list_price = PQgetvalue($parts, $i, $k++);
      $list_curr = PQgetvalue($parts, $i, $k++);
      $sell_price = PQgetvalue($parts, $i, $k++);
      $sell_curr = PQgetvalue($parts, $i, $k++);
      $weight_kg = PQgetvalue($parts, $i, $k++);
      $pnotes = PQgetvalue($parts, $i, $k++);
      $ppriceupdate = PQgetvalue($parts, $i, $k++);
      
      $supplier = PQgetvalue($parts, $i, $k++);
      $contact = PQgetvalue($parts, $i, $k++);
      $phone = PQgetvalue($parts, $i, $k++);
      $fax = PQgetvalue($parts, $i, $k++);
      $ml = PQgetvalue($parts, $i, $k++);
      $email = "<a href=mailto:$ml>$ml</a>";
      
      $spoid = PQgetvalue($parts, $i, $k++);
      $poid = PQgetvalue($parts, $i, $k++);
      $soid = PQgetvalue($parts, $i, $k++);

      $query = "select name from make where id = $mk;";
      $ct = PQexec($conn, $query);

      $make = PQgetvalue($ct, 0, 0);
      PQclear($ct);

      $query = "select alt_number from alternate where oem_number = \'$number\' and oem_make = $mk;";
      $alt = PQexec($conn, $query);
      $j = PQntuples($alt);
      $alternates = "";

      for $t (0 .. $j-1) {
	$altnumber = PQgetvalue($alt, $t, 0);
	$alternates .= "<a href=/alternate/search.pl?$altnumber>$altnumber</a>";
	$alternates .= " ";
      }
      PQclear($alt);

      write;

      print "<p>
      [ <a href=edit.pl?$number&$spoid&$poid>Edit</a> ]
      [ <a href=delete.pl?$number&$spoid>Delete</a> ]
      ";

    }
  } else {
    print "<p><hr>
    <font color=red size=+3><a href=add.pl?$item>$item</a> not on file!</font> <-- Click on number to add!
    ";
  }
  PQclear($parts);
}

PQfinish($conn);

print "
<p><hr>
[ Delete ] will remove the part from the SUPPLY table only!
<br>To remove the part from the PARTS table
go to the <a href=/parts/search.html>search</a> screen for parts.

</body>
</html>
";


